#include "chain_of_responsibility.hpp"

int PersonA::getDayoff()
{
	return m_Dayoff;
}

string PersonA::getName()
{
	return m_Name;
}

string PersonA::getReason()
{
	return m_Reason;
}

void PersonA::setLeader(Manager* pLeader)
{
	m_pLeader = pLeader;
}

void PersonA::Request()
{
	cout << m_Name << "" << m_Dayoff << "죬ɣ" << m_Reason << endl;
	if (m_pLeader != nullptr)
	{
		m_pLeader->handleRequest(this);
	}
}

string Manager::getName()
{
	return m_Name;
}

string Manager::getTitle()
{
	return m_Title;
}

void Manager::setNextHander(Manager* p_NextHandler)
{
	m_pNextHandle = p_NextHandler;
}

void Supervisor::handleRequest(PersonA* pPerson)
{
	if (pPerson->getDayoff() <= 2)
	{
		cout << "ͬ" << pPerson->getName() << "٣ǩˣ" << getName() << "(" << getTitle() << ")" << endl;
	}
	if (m_pNextHandle != nullptr)
	{
		m_pNextHandle->handleRequest(pPerson);
	}
}


void DepartmentManager::handleRequest(PersonA* pPerson)
{
	if (pPerson->getDayoff() <= 5 && pPerson->getDayoff() > 2)
	{
		cout << "ͬ" << pPerson->getName() << "٣ǩˣ" << getName() << "(" << getTitle() << ")" << endl;
	}
	if (m_pNextHandle != nullptr)
	{
		m_pNextHandle->handleRequest(pPerson);
	}
}

void CEO::handleRequest(PersonA* pPerson)
{
	if (pPerson->getDayoff() > 5)
	{
		cout << "ͬ" << pPerson->getName() << "٣ǩˣ" << getName() << "(" << getTitle() << ")" << endl;
	}
	if (m_pNextHandle != nullptr)
	{
		m_pNextHandle->handleRequest(pPerson);
	}
}

void Administrator::handleRequest(PersonA* pPerson)
{

	cout << pPerson->getName() << "ˣʵѱˣ"
		<< getName() << "(" << getTitle() << ")" << endl;

	cout << endl;

	if (m_pNextHandle != nullptr)
	{
		m_pNextHandle->handleRequest(pPerson);
	}
}