#include "combination.hpp"

bool ComputerComponent::isComposite()
{
	return false;
}

void ComputerComponent::startup(string indent)
{
	cout << indent << m_name << " " << "׼ʼ" << endl;
}

void ComputerComponent::shutdown(string indent)
{
	cout << indent << m_name << " " << "" << endl;
}

void CPU::showInfo(string indent)
{
	cout << indent << "CPU" << indent << "Խи㡣" << endl;
}

void MemoryCard::showInfo(string indent)
{
	cout << indent << "ڴ棺" << indent << "Իݣдٶȿ졣" << endl;
}

void HardDisk::showInfo(string indent)
{
	cout << indent << "Ӳ̣" << indent << "ô洢ݣ洢" << endl;
}

void GraphicsCard::showInfo(string indent)
{
	cout << indent << "Կ" << indent << "Ըټʹͼͼ" << endl;
}

void Battery::showInfo(string indent)
{
	cout << indent << "Դ" << indent << "Գ硣" << endl;
}

void Fan::showInfo(string indent)
{
	cout << indent << "ȣ" << indent << "CPUɢȡ" << endl;
}

void Displayer::showInfo(string indent)
{
	cout << indent << "ʾ" << indent << "ݵʾ" << endl;
}

void ComputerCompsite::showInfo(string indent)
{
	cout << m_name << "²ɣ" << endl;
	vector<ComputerComponent*>::iterator iter;
	for (iter = m_components.begin(); iter != m_components.end(); iter++)
	{
		(*iter)->showInfo(indent);
	}
}

bool ComputerCompsite::isComposite()
{
	return true;
}

void ComputerCompsite::addComponent(ComputerComponent* component)
{
	m_components.push_back(component);
}

void ComputerCompsite::removeComponent(ComputerComponent* component)
{
	vector<ComputerComponent*>::iterator iter = find(m_components.begin(), m_components.end(), component);
	if (iter != m_components.end())
	{
		m_components.erase(iter);
	}
}

void ComputerCompsite::startup(string indent)
{
	ComputerComponent::startup(indent);
	indent += "\t";

	vector<ComputerComponent*>::iterator iter;
	for (iter = m_components.begin(); iter != m_components.end(); iter++)
	{
		(*iter)->startup();
	}
}

void ComputerCompsite::shutdown(string indent)
{
	ComputerComponent::shutdown(indent);
	indent += "\t";

	vector<ComputerComponent*>::iterator iter;
	for (iter = m_components.begin(); iter != m_components.end(); iter++)
	{
		(*iter)->shutdown();
	}
}

void Mainboard::showInfo(string indent)
{
	cout << indent << "壺";
	ComputerCompsite::showInfo(indent);
}

void ComputerCase::showInfo(string indent)
{
	cout << indent << "䣺";
	ComputerCompsite::showInfo(indent);
}

void Computer::showInfo(string indent)
{
	cout << indent << "ԣ";
	ComputerCompsite::showInfo(indent); 
}
