#include "facade.hpp"

void ZIPModel::compress(string srcFilePath, string dstFilePath)
{
	cout << "ZIPģڽС" << srcFilePath << "ѹ" << endl;
	cout << "ļѹɹѱ" << dstFilePath << "" << endl;
}

void ZIPModel::decompress(string srcFilePath, string dstFilePath)
{
	cout << "ZIPģڽС" << srcFilePath << "Ľѹ" << endl;
	cout << "ļѹɹѱ" << dstFilePath << "" << endl;
}

void ZModel::compress(string srcFilePath, string dstFilePath)
{
	cout << "7ZģڽС" << srcFilePath << "ѹ" << endl;
	cout << "ļѹɹѱ" << dstFilePath << "" << endl;
}

void ZModel::decompress(string srcFilePath, string dstFilePath)
{
	cout << "7ZģڽС" << srcFilePath << "Ľѹ" << endl;
	cout << "ļѹɹѱ" << dstFilePath << "" << endl;
}

void RARModel::compress(string srcFilePath, string dstFilePath)
{
	cout << "RARģڽС" << srcFilePath << "ѹ" << endl;
	cout << "ļѹɹѱ" << dstFilePath << "" << endl;
}

void RARModel::decompress(string srcFilePath, string dstFilePath)
{
	cout << "RARģڽС" << srcFilePath << "Ľѹ" << endl;
	cout << "ļѹɹѱ" << dstFilePath << "" << endl;
}

CompressionFacade::CompressionFacade(ZIPModel* pZipModel, RARModel* pRarModel, ZModel* pZModel)
{
	m_pRarModel = pRarModel;
	m_pZModel = pZModel;
	m_pZipModel = pZipModel;
}

CompressionFacade::~CompressionFacade()
{
	if (m_pRarModel != nullptr)
	{
		delete m_pRarModel;
	}

	if (m_pZModel != nullptr)
	{
		delete m_pZModel;
	}

	if (m_pZipModel != nullptr)
	{
		delete m_pZipModel;
	}
}

void CompressionFacade::compress(string srcFilePath, string dstFilePath, string type)
{
	string fullName = dstFilePath + '.' + type;
	if (type == "zip")
	{
		m_pZipModel->compress(srcFilePath, fullName);
	}
	else if (type == "rar")
	{
		m_pRarModel->compress(srcFilePath, fullName);
	}
	else if (type == "7z")
	{
		m_pZModel->compress(srcFilePath, fullName);
	}
	return;

}

void CompressionFacade::decompress(string srcFilePath, string dstFilePath)
{
	string::iterator iter = find(srcFilePath.begin(), srcFilePath.end(), '.');
	string baseName(srcFilePath.begin(), iter);

	string extName(iter, srcFilePath.end());

	if (extName == "zip")
	{
		m_pZipModel->decompress(srcFilePath, baseName);
	}
	else if (extName == "rar")
	{
		m_pRarModel->decompress(srcFilePath, baseName);
	}
	else if (extName == "7z")
	{
		m_pZModel->decompress(srcFilePath, baseName);
	}
	return;
}
