#include "simple_factory.hpp"

Pen::Pen(string name)
{
	m_name = name;
}

string Pen::getName()
{
	return m_name;
}

PenType LinePen::getType()
{
	return PenTypeLine;
}

PenType RectanglePen::getType()
{
	return PenTypeRect;
}

PenType EllipsePen::getType()
{
	return PenTypeEllipse;
}

Pen* PenFactory::CreatePen(PenType pentype)
{
	if (m_PenProduct.find(pentype) == m_PenProduct.end())
	{
		if (pentype == PenTypeLine)
		{
			m_PenProduct[pentype] = new LinePen("ֱ߻");
		}
		else if(pentype == PenTypeRect)
		{
			m_PenProduct[pentype] = new RectanglePen("λ");
		}
		else if (pentype == PenTypeEllipse)
		{
			m_PenProduct[pentype] = new EllipsePen("Բ");
		}
		else
		{
			return nullptr;
		}
	}
	return m_PenProduct[pentype];
}
